//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define SQLExportTempFile "C:\\SQLExp.txt"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char gsImportTable[64];

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ProcessCommand(char *ReceivedData, int ReceivedSize)
{
    int FlagLength = 0;
    int FlaggedLength = 0;
    char FlaggedData[MaxReceiveSize + 1];

    if((FlagLength = CompareFlagedString(ReceivedData, "::ImportTable:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';
        
        strcpy(gsImportTable, FlaggedData);
        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::FileCRC")))
    {
        sprintf(FlaggedData, "::FileCRC:%d", glDataCRC);
        SimpleClientSend(FlaggedData);
        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::Statement:")))
    {
        char StatTemp[255];

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        sprintf(StatTemp, "Exporting %s data.", gsImportTable);
        InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);

        int SQL_Import_Result = ExportSQLResults(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase, FlaggedData, gsImportTable, SQLExportTempFile);

        if(SQL_Import_Result == SQL_IMPORT_RESULT_ZEROROWS)
        {
            SimpleClientSend("::RequestNextStatement");
            return COMMAND_RESULT_OK;
        }
        else if (SQL_Import_Result == SQL_IMPORT_RESULT_OK){
            sprintf(FlaggedData, "::FileSize:%d", Get_FileSize(SQLExportTempFile));
            SimpleClientSend(FlaggedData);

            sprintf(FlaggedData, "::FileName:%s", gsImportTable);
            SimpleClientSend(FlaggedData);

            Sleep(1000);

            SendFileData(SQLExportTempFile);
            return COMMAND_RESULT_OK;
        }
        else if (SQL_Import_Result == SQL_IMPORT_RESULT_ERROR){
            // There was an error exporting the SQL data.
            // FIXME: What do we do now, Request the next statement or disconnect?
            SimpleClientSend("::RequestNextStatement");
            return COMMAND_RESULT_OK;
        }

        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::LastImportSuccess")))
    {
        SQLBasics SQL;
        HSTMT UpdateHandle;
        char xStatement[255];

        if(!SQL.DBConnect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase))
        {
            printf("ImportSuccess DBConnect: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }

        sprintf(xStatement, "UPDATE %s SET Portal_Dirty = 0 WHERE Portal_Dirty = 2", gsImportTable);
        if(!SQL.DBExecute(xStatement, &UpdateHandle))
        {
            DBCloseCursor(UpdateHandle);
            SQL.DBDisconnect();
            printf("ImportSuccess UPDATE DBexecute: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }
        DBCloseCursor(UpdateHandle);

        SimpleClientSend("::RequestNextStatement");

        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::LastImportFailed")))
    {
        InsertListBoxItem(MDI.RecvEdit_hWnd, "SQL data failed to import on server side.", -1);

        SQLBasics SQL;
        HSTMT UpdateHandle;
        char xStatement[255];

        if(!SQL.DBConnect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase))
        {
            printf("ImportFailed DBConnect: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }

        sprintf(xStatement, "UPDATE %s SET Portal_Dirty = 1 WHERE Portal_Dirty = 2", gsImportTable);
        if(!SQL.DBExecute(xStatement, &UpdateHandle))
        {
            DBCloseCursor(UpdateHandle);
            SQL.DBDisconnect();
            printf("ImportFailed UPDATE DBexecute: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }
        DBCloseCursor(UpdateHandle);

        SimpleClientSend("::RequestNextStatement");

        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::DataCRCFailed")))
    {
        InsertListBoxItem(MDI.RecvEdit_hWnd, "Data CRC failed.", -1);
        // FIXME: What do we do now, Request the next statement or disconnect?
        SimpleClientSend("::RequestNextStatement");
        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::Error:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        InsertListBoxItem(MDI.RecvEdit_hWnd, FlaggedData, -1);
        return COMMAND_RESULT_DISCONNECT;
    }
    else if(strcmp(ReceivedData, "::EndOfStatements") == 0)
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        InsertListBoxItem(MDI.RecvEdit_hWnd, "End of statements.", -1);
        return COMMAND_RESULT_DISCONNECT;
    }

    InsertListBoxItem(MDI.RecvEdit_hWnd, ReceivedData, -1);
	return COMMAND_RESULT_UNKNOWN;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

